#include <math.h>  
#include <stdlib.h> 

#define ACCELEROMETER_SENSITIVITY 16384.0
#define GYROSCOPE_SENSITIVITY 131.0
#define x 0
#define y 1
#define z 2
#define M_PI 3.14159265359f	    
 
#define dt 0.005							// 5 ms sample rate!    
 
void ComplementaryFilter(short accData[3], short gyrData[3], float *pitch, float *roll)
{
    float pitchAcc, rollAcc;               
 
    // Integrate the gyroscope data -> int(angularSpeed) = angle
    *pitch += ((float)gyrData[0] / GYROSCOPE_SENSITIVITY) * dt; // Angle around the X-axis
    *roll -= ((float)gyrData[1] / GYROSCOPE_SENSITIVITY) * dt;    // Angle around the Y-axis
 
    // Compensate for drift with accelerometer data if !bullshit
    // Sensitivity = -2 to 2 G at 16Bit -> 2G = 32768 && 0.5G = 8192
    int forceMagnitudeApprox = abs(accData[x]) + abs(accData[y]) + abs(accData[z]);
    if (forceMagnitudeApprox > 8192 && forceMagnitudeApprox < 32767)
    {
	// Turning around the X axis results in a vector on the Y-axis
        pitchAcc = atan2f((float)accData[y], sqrtf((float)accData[z] * (float)accData[z] +(float)accData[x] * (float)accData[x])) * 180 / M_PI;
        *pitch = *pitch * 0.98f + pitchAcc * 0.02f;
 
	// Turning around the Y axis results in a vector on the X-axis
        rollAcc = atan2f((float)accData[x], sqrtf((float)accData[z] * (float)accData[z] +(float)accData[y] * (float)accData[y])) * 180 / M_PI;
        *roll = *roll * 0.98f + rollAcc * 0.02f;
    }
} 


